extends ../_docs-template

block vars
  - var title = 'Progressbar | Framework7 Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu
  .docs-content
    .motion-docs-page-title
      h1 Progressbar
      script(src="/js/motion/progressbar.js")
      f7-motion-progressbar(motion)

    p In addition to <a href="preloader.html">Preloader</a> Framework7 also comes with fancy animated determinate and infinite/indeterminate progressbars to indicate activity.

    h2 Determinate Progressbar
    p When progressbar is determinate it indicates how long an operation will take when the percentage complete is detectable.
    p Let's look at layout of determinate progressbar:
    :code(lang="html")
          <div class="progressbar" data-progress="20">
            <span></span>
          </div>
    p Where <b>data-progress="20"</b> - current progress (in percents). Note that this data attribute sets progress only on page load. If you need to change it later it should be done via API.

    h2 Infinite Progressbar
    p When progressbar is infinite/indeterminate it requests that the user wait while something finishes when it’s not necessary to indicate how long it will take.
    p Let's look at layout of infinite progressbar:
    :code(lang="html")
          <div class="progressbar-infinite"></div>

    h2 Progressbar Colors
    p Progressbar supports all <a href="color-themes.html">default colors</a>. So to change its color just add `color-[color]` class to progressbar element.
    :code(lang="html")
      <!-- Red progressbar -->
      <div class="progressbar color-red" data-progress="20">
        <span></span>
      </div>

      <!-- Green progressbar -->
      <div class="progressbar color-green" data-progress="50">
        <span></span>
      </div>

      <!-- Yellow infinite progressbar -->
      <div class="progressbar-infinite color-yellow"></div>

      <!-- Multicolor infinite progressbar -->
      <div class="progressbar-infinite color-multi"></div>
    h2 Progressbar API
    p Progressbar comes with API that allows you to control Progressbar's progress, show and hide it. Let's look on appropriate App's properties and methods:
    .method-wrap
      p
        span.method app.progressbar.set(<span>el, progress, duration</span>)
        |  - set progress for Determinate Progressbar.
      ul.method-parameters
        li
          span.parameter el
          |  - <span class="parameter-type">string</span> or <span class="parameter-type">HTMLElement</span>. Progressbar element or element containing progressbar element. If string - CSS selector of such element.
        li
          span.parameter progress
          |  - <span class="parameter-type">number</span>. Progress in percents (from 0 to 100)
        li
          span.parameter duration
          |  - <span class="parameter-type">number</span>. Transition duration of progress change animation (in ms)
        li.method-returns This method returns Progressbar HTMLElement
    .method-wrap
      p
        span.method app.progressbar.set(<span>progress, duration</span>)
        |  - set progress for Determinate Progressbar which is under the app root element.
      ul.method-parameters
        li
          span.parameter progress
          |  - <span class="parameter-type">number</span>. Progress in percents (from 0 to 100)
        li
          span.parameter duration
          |  - <span class="parameter-type">number</span>. Transition duration of progress change animation (in ms)
        li.method-returns This method returns Progressbar HTMLElement
    .method-wrap
      p
        span.method app.progressbar.show(<span>el</span>, <span>progress</span>, <span>color</span>)
        |  - create and show or just show (if already presented) progressbar.
      ul.method-parameters
        li
          span.parameter el
          |  - <span class="parameter-type">string</span> or <span class="parameter-type">HTMLElement</span>. Progressbar element container or element containing progressbar element. If string - CSS selector of such element. <em>Optional</em>
        li
          span.parameter progress
          |  - <span class="parameter-type">number</span>. Progress in percents (from 0 to 100). <em>Optional</em>
        li
          span.parameter color
          |  - <span class="parameter-type">string</span>. Color of progressbar, for example "white", "red", etc. from available <a href="color-themes.html">color themes</a>. <em>Optional</em>
        li.method-returns This method returns Progressbar HTMLElement
      p All arguments here are optional:
      ul
        li If you omit `el` argument, it will look for (or create) progressbar element under app root
        li If you omit `progress`, it will show/create infinite progressbar
        li If you omit all arguments, then it will show/create infinite progressbar under the app root with default color
    .method-wrap
      p
        span.method app.progressbar.hide(<span>el</span>)
        |  - hide Progressbar.
      ul.method-parameters
        li
          span.parameter el
          |  - <span class="parameter-type">string</span> or <span class="parameter-type">HTMLElement</span>. Progressbar element container or element containing progressbar element. If string - CSS selector of such element. If not specified then it will look for such element under the app root element.

    +cssVars('progressbar')


    h2 Examples
    +examplePreview('core', 'progressbar.html', 'progressbar')
